#include <stdio.h>
#include <iostream.h>

#include "gui_muse.h"
#include "jmixer.h"
#include "libsync/synchronous.h"
#include <FL/fl_ask.H>

static LTI::Synchronous *dealer;
static Stream_mixer *mixer;

void init_callbacks(Stream_mixer *mix, const LTI::Synchronous *deal) {
  mixer = mix;
  dealer = (LTI::Synchronous *)deal;
}

void set_channel(Fl_Widget *o, void *ch) {
  
  int song = ((Fl_Browser *)o)->value();
  
  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();
  
  mixer->set_channel(*(int*)ch,song);
}

void play_channel(Fl_Widget *o, void *ch) {

  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();
  mixer->play_channel(*(int*)ch);
  
}

void stop_channel(Fl_Widget *o, void *ch) {
  
  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();

  mixer->stop_channel(*(int*)ch);
}

void pause_channel(Fl_Widget *o, void *ch) {

  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();

  mixer->pause_channel(*(int*)ch);
}

void set_volume(Fl_Widget *o, void *ch) {

  float vol = ((Fl_Slider *)o)->value();

  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();

  mixer->set_volume(*(int*)ch,vol);
}

void set_position(Fl_Widget *o, void *ch) {
  
  float pos = ((Fl_Slider *)o)->value();
  
  dealer->select.call(0,mixer,Stream_mixer::id_stream_mixer);
  dealer->wait();
  
  mixer->set_position(pos,*(int*)ch);
}

void gui_quit(Fl_Menu_* o, void* v) {
  if(fl_ask("Sure to quit?"))
    ((Amuse*)(o->parent()->user_data()))->quit = true;
}
