#ifndef __GUI_CALLBACKS_H__
#define __GUI_CALLBACKS_H__

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Round_Button.H>

#include "jmixer.h"
#include "libsync/synchronous.h"

void init_callbacks(Stream_mixer *mix, const LTI::Synchronous *deal);
void set_channel(Fl_Widget *o, void *ch);
void play_channel(Fl_Widget *o, void *ch);
void stop_channel(Fl_Widget *o, void *ch);
void pause_channel(Fl_Widget *o, void *ch);
void set_volume(Fl_Widget *o, void *ch);
void set_position(Fl_Widget *o, void *ch);
void gui_quit(Fl_Menu_* o, void* v);

#endif
