#ifndef __JMIXER_H
#define __JMIXER_H

#include <unistd.h>
#include <stdlib.h>

#include "generic.h"
#include "inchannels.h"
#include "outchannels.h"
#include "libsync/synchronous.h"
#include "gui_muse.h"

class Stream_mixer: public LTI::Object {

private:

  Amuse *gui;
  bool have_gui;

  short audio_buffer[BUF_SIZE];
  int process_buffer[BUF_SIZE];

  int dsp;
  bool fullduplex;

  LiveIn *livein;
  
  void close_soundcard();
  void upd_timeline(int ch, float res);
  
public:
  Stream_mixer();

  void run();

  void register_gui(Amuse *reg_gui);
  bool open_soundcard();
  bool set_icecast(char *ip, int port, char *pass, char *mountpoint, int bps);
  void stop_icecast();
  void cafudda();
  void pause_channel(int ch);
  void play_channel(int ch);
  void stop_channel(int ch);
  void set_channel(int ch, int playlist_pos);
  void set_volume(int ch, float vol);
  void set_speed(int ch, float speed);
#ifndef MPG123
  void set_position(float pos, int ch);
#endif
  void dump_status();
  bool set_live(bool stat);
  void set_playlist(int ch, char *pl);

#ifdef MPG123
  Mp3Channel mp3ch[MAX_CHANNELS];
#else
  XaudioChannel xach[MAX_CHANNELS];
#endif

  IcecastOut ice;

  /* this is for the libsync - registering synchronized id */
  static const int id_stream_mixer = 1;

  bool dspout;
  bool icecastout;
  bool quit;

  int *client;

  ~Stream_mixer();
};

#endif
