#ifndef __OUTCHANNELS_H
#define __OUTCHANNELS_H

extern "C" {
#include "libshout/shout.h"
#include "lame/lame.h"
}

class IcecastOut {
private:
  shout_conn_t ice_conn;
  lame_global_flags enc_flags;
  
  char ip[20];
  int port;
  char pass[64];
  char mountpoint[64];
  int bps;
  bool initialized;

public:
  IcecastOut();

  bool start();
  void stop();
  bool set(char *naddress, int nport, char *npass, char *nmountpoint, int nbps);
  bool send(short *sendbuf, long len);
  void sync();
  void init_encoder(int bps);
  int encode(short int *pcm,int num,int *dest,int size);

  bool running;

  ~IcecastOut();
};

#endif
